From e6f993b7933c65f4f32925fe959807c8ae977a60 Mon Sep 17 00:00:00 2001
From: Ludwig Krispenz <lkrispen@redhat.com>
Date: May 28 2020 12:54:29 +0000
Subject: [PATCH 3/3] Additional patch for problems raised during review


---

diff --git a/ldap/servers/plugins/replication/cl5_api.c b/ldap/servers/plugins/replication/cl5_api.c
index 8c281c1..724b35a 100644
--- a/ldap/servers/plugins/replication/cl5_api.c
+++ b/ldap/servers/plugins/replication/cl5_api.c
@@ -162,7 +162,6 @@ typedef struct cl5iterator
 /* this structure defines 5.0 changelog internals */
 typedef struct cl5desc
 {
-    char *dbDir;            /* no longer needed, leave here for upgrade functions */
     DB_ENV *dbEnv;          /* db environment shared by all db files            */
     CL5OpenMode dbOpenMode; /* how we open db                                    */
     CL5State dbState;       /* changelog current state                            */
@@ -411,6 +410,8 @@ cl5Close()
 
     s_cl5Desc.dbState = CL5_STATE_CLOSED;
 
+    s_cl5Desc.dbEnv = NULL;
+
     slapi_rwlock_unlock(s_cl5Desc.stLock);
 
     return rc;
@@ -1376,10 +1377,16 @@ cldb_SetReplicaDB(Replica *replica, void *arg)
     }
 
     /* get cl configuration for backend */
-    back_info_config_entry config_entry;
+    back_info_config_entry config_entry = {0};
     config_entry.dn = "cn=changelog";
     changelog5Config config = {};
     rc = slapi_back_ctrl_info(be, BACK_INFO_CLDB_GET_CONFIG, (void *)&config_entry);
+    if (rc !=0 || config_entry.ce == NULL) {
+        slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
+                      "cldb_SetReplicaDB - failed to read config for changelog\n");
+        return CL5_BAD_DATA;
+    }
+
     changelog5_extract_config(config_entry.ce, &config);
     changelog5_register_config_callbacks(slapi_entry_get_dn_const(config_entry.ce), replica);
     slapi_entry_free(config_entry.ce);
@@ -1448,7 +1455,7 @@ cldb_StopThreads(Replica *replica, void *arg)
     interval = PR_MillisecondsToInterval(100);
     while ((threads = slapi_counter_get_value(cldb->clThreads)) > 0) {
         slapi_log_err(SLAPI_LOG_REPL, repl_plugin_name_cl,
-                      "_cl5Close -Waiting for threads to exit: %lu thread(s) still active\n",
+                      "cldb_StopThreads -Waiting for threads to exit: %lu thread(s) still active\n",
                       threads);
          DS_Sleep(interval);
     }
@@ -3713,8 +3720,8 @@ _cl5WriteOperationTxn(cldb_Handle *cldb, const slapi_operation_parameters *op, v
         rc = cldb->db->put(cldb->db, txnid, &key, data, 0);
         if (CL5_OS_ERR_IS_DISKFULL(rc)) {
             slapi_log_err(SLAPI_LOG_CRIT, repl_plugin_name_cl,
-                          "_cl5WriteOperationTxn - Changelog (%s) DISK FULL; db error - %d %s\n",
-                          s_cl5Desc.dbDir, rc, db_strerror(rc));
+                          "_cl5WriteOperationTxn - Changelog DISK FULL; db error - %d %s\n",
+                          rc, db_strerror(rc));
             rc = CL5_DB_ERROR;
             goto done;
         }
@@ -4479,6 +4486,13 @@ cl5Import(Slapi_PBlock *pb)
 {
     slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name_cl,
                           "cl5Export - Importing changelog\n");
+
+    /* TBD
+     * as in cl5Export 
+     * get ldif dir from pblock
+     * generate cl ldif name 
+     * call clImportLDIF
+     */
     return 0;
 }
 
diff --git a/ldap/servers/plugins/replication/repl5_replica_config.c b/ldap/servers/plugins/replication/repl5_replica_config.c
index e05418b..ae1feb7 100644
--- a/ldap/servers/plugins/replication/repl5_replica_config.c
+++ b/ldap/servers/plugins/replication/repl5_replica_config.c
@@ -1226,7 +1226,6 @@ replica_execute_ldif2cl_task(Replica *replica, char *returntext)
     int rc, imprc = 0;
     char fName[MAXPATHLEN];
     char *clDir = NULL;
-    changelog5Config config;
 
     if (cl5GetState() != CL5_STATE_OPEN) {
         PR_snprintf(returntext, SLAPI_DSE_RETURNTEXT_SIZE, "changelog is not open");
@@ -1280,21 +1279,18 @@ replica_execute_ldif2cl_task(Replica *replica, char *returntext)
                       "replica_execute_ldif2cl_task - %s\n", returntext);
         imprc = LDAP_OPERATIONS_ERROR;
     }
-    changelog5_read_config(&config);
     /* restart changelog */
     rc = cl5Open();
     if (CL5_SUCCESS == rc) {
         rc = LDAP_SUCCESS;
     } else {
         slapi_log_err(SLAPI_LOG_ERR, repl_plugin_name,
-                      "replica_execute_ldif2cl_task - Failed to start changelog at %s\n",
-                      config.dir ? config.dir : "null config dir");
+                      "replica_execute_ldif2cl_task - Failed to start changelog after import\n");
         rc = LDAP_OPERATIONS_ERROR;
     }
 
 bail:
     slapi_ch_free_string(&clDir);
-    changelog5_config_done(&config);
 
     /* if cl5ImportLDIF returned an error, report it first. */
     return imprc ? imprc : rc;
diff --git a/ldap/servers/slapd/back-ldbm/db-bdb/bdb_layer.c b/ldap/servers/slapd/back-ldbm/db-bdb/bdb_layer.c
index 1291e4c..5f3e11f 100644
--- a/ldap/servers/slapd/back-ldbm/db-bdb/bdb_layer.c
+++ b/ldap/servers/slapd/back-ldbm/db-bdb/bdb_layer.c
@@ -74,7 +74,8 @@ static int commit_good_database(bdb_config *priv, int mode);
 static int read_metadata(struct ldbminfo *li);
 static int count_dbfiles_in_dir(char *directory, int *count, int recurse);
 static int dblayer_override_libdb_functions(void);
-static int dblayer_force_checkpoint(struct ldbminfo *li);
+static int bdb_force_checkpoint(struct ldbminfo *li);
+static int bdb_force_logrenewal(struct ldbminfo *li);
 static int log_flush_threadmain(void *param);
 static int dblayer_delete_transaction_logs(const char *log_dir);
 static int dblayer_is_logfilename(const char *path);
@@ -2560,7 +2561,7 @@ bdb_rm_db_file(backend *be, struct attrinfo *a, PRBool use_lock, int no_force_ch
      Force a checkpoint here to break deadlock.
   */
     if (0 == no_force_checkpoint) {
-        dblayer_force_checkpoint(li);
+        bdb_force_checkpoint(li);
     }
 
     if (0 == dblayer_get_index_file(be, a, &db, 0 /* Don't create an index file
@@ -3655,7 +3656,7 @@ checkpoint_threadmain(void *param)
     }
 
     /* work around a problem with newly created environments */
-    dblayer_force_checkpoint(li);
+    bdb_force_checkpoint(li);
 
     PR_Lock(li->li_config_mutex);
     checkpoint_interval = (time_t)BDB_CONFIG(li)->bdb_checkpoint_interval;
@@ -3664,7 +3665,7 @@ checkpoint_threadmain(void *param)
     debug_checkpointing = BDB_CONFIG(li)->bdb_debug_checkpointing;
     PR_Unlock(li->li_config_mutex);
 
-    /* assumes dblayer_force_checkpoint worked */
+    /* assumes bdb_force_checkpoint worked */
     /*
      * Importantly, the use of this api is not affected by backwards time steps
      * and the like. Because this use relative system time, rather than utc,
@@ -3807,7 +3808,7 @@ checkpoint_threadmain(void *param)
         }
     }
     slapi_log_err(SLAPI_LOG_TRACE, "checkpoint_threadmain", "Check point before leaving\n");
-    rval = dblayer_force_checkpoint(li);
+    rval = bdb_force_checkpoint(li);
 error_return:
 
     DECR_THREAD_COUNT(pEnv);
@@ -4065,7 +4066,7 @@ read_metadata(struct ldbminfo *li)
 
 /* handy routine for checkpointing the db */
 static int
-dblayer_force_checkpoint(struct ldbminfo *li)
+bdb_force_checkpoint(struct ldbminfo *li)
 {
     int ret = 0, i;
     dblayer_private *priv = li->li_dblayer_private;
@@ -4080,7 +4081,7 @@ dblayer_force_checkpoint(struct ldbminfo *li)
 
     if (BDB_CONFIG(li)->bdb_enable_transactions) {
 
-        slapi_log_err(SLAPI_LOG_TRACE, "dblayer_force_checkpoint", "Checkpointing database ...\n");
+        slapi_log_err(SLAPI_LOG_TRACE, "bdb_force_checkpoint", "Checkpointing database ...\n");
 
         /*
      * DB workaround. Newly created environments do not know what the
@@ -4092,7 +4093,7 @@ dblayer_force_checkpoint(struct ldbminfo *li)
         for (i = 0; i < 2; i++) {
             ret = dblayer_txn_checkpoint(li, pEnv, PR_FALSE, PR_TRUE);
             if (ret != 0) {
-                slapi_log_err(SLAPI_LOG_ERR, "dblayer_force_checkpoint", "Checkpoint FAILED, error %s (%d)\n",
+                slapi_log_err(SLAPI_LOG_ERR, "bdb_force_checkpoint", "Checkpoint FAILED, error %s (%d)\n",
                               dblayer_strerror(ret), ret);
                 break;
             }
@@ -4102,6 +4103,34 @@ dblayer_force_checkpoint(struct ldbminfo *li)
     return ret;
 }
 
+/* routine to force all existing transaction logs to be cleared
+ * This is necessary if the transaction logs can contain references
+ * to no longer existing files, but would be processed in a fatal
+ * recovery (like in backup/restore).
+ * There is no straight forward way to do this, but the following
+ * scenario should work:
+ *
+ * 1. check for no longer needed transaction logs by
+ *      calling log_archive()
+ * 2. delete these logs (1and2 similar to checkpointing
+ * 3. force a checkpoint
+ * 4. use log_printf() to write a "comment" to the current txn log
+ *      force a checkpoint
+ *      this could be done by writing once about 10MB or
+ *      by writing smaller chunks in a loop
+ * 5. force a checkpoint and check again
+ *  if a txn log to remove exists remove it and we are done
+ *  else repeat step 4
+ *
+ * NOTE: double check if force_checkpoint also does remove txn files
+ * then the check would have to be modified
+ */
+static int
+bdb_force_logrenewal(struct ldbminfo *li)
+{
+    return 0;
+}
+
 static int
 _dblayer_delete_aux_dir(struct ldbminfo *li, char *path)
 {
@@ -4273,7 +4302,7 @@ int
 dblayer_delete_instance_dir(backend *be)
 {
     struct ldbminfo *li = (struct ldbminfo *)be->be_database->plg_private;
-    int ret = dblayer_force_checkpoint(li);
+    int ret = bdb_force_checkpoint(li);
 
     if (ret != 0) {
         return ret;
@@ -4882,7 +4911,7 @@ bdb_backup(struct ldbminfo *li, char *dest_dir, Slapi_Task *task)
      */
 
     /* do a quick checkpoint */
-    dblayer_force_checkpoint(li);
+    bdb_force_checkpoint(li);
     dblayer_txn_init(li, &txn);
     return_value = dblayer_txn_begin_all(li, NULL, &txn);
     if (return_value) {
@@ -6067,6 +6096,7 @@ bdb_back_ctrl(Slapi_Backend *be, int cmd, void *info)
                     char *newFile = slapi_ch_smprintf("%s/changelog.db", instancedir);
                     rc = pEnv->dbrename(pEnv, 0, oldFile, 0, newFile, 0);
                     slapi_ch_free_string(&instancedir);
+                    bdb_force_logrenewal(li);
                 }
             }
         }

